aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/bcm47xx/base-files/etc
diff options
context:
space:
mode:
Diffstat (limited to 'target/linux/bcm47xx/base-files/etc')
-rwxr-xr-xtarget/linux/bcm47xx/base-files/etc/board.d/01_network206
-rw-r--r--target/linux/bcm47xx/base-files/etc/diag.sh33
-rwxr-xr-xtarget/linux/bcm47xx/base-files/etc/init.d/wmacfixup33
-rw-r--r--target/linux/bcm47xx/base-files/etc/uci-defaults/03_network_migration29
-rw-r--r--target/linux/bcm47xx/base-files/etc/uci-defaults/09_fix_crc7
5 files changed, 308 insertions, 0 deletions
diff --git a/target/linux/bcm47xx/base-files/etc/board.d/01_network b/target/linux/bcm47xx/base-files/etc/board.d/01_network
new file mode 100755
index 0000000000..e6311d8139
--- /dev/null
+++ b/target/linux/bcm47xx/base-files/etc/board.d/01_network
@@ -0,0 +1,206 @@
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2006-2015 OpenWrt.org
+
+. /lib/functions/system.sh
+. /lib/functions/uci-defaults.sh
+
+configure_by_vlanports() {
+ local vlan0ports="$(nvram get vlan0ports)"
+ local vlan1ports="$(nvram get vlan1ports)"
+ local vlan2ports="$(nvram get vlan2ports)"
+ local cpuport="$(swconfig dev switch0 help 2>/dev/null | sed -ne "s|.*cpu @ \([0-9]*\).*|\1|p")"
+
+ if [ "${vlan0ports:0:9}" = "0 1 2 3 8" -a "${vlan1ports:0:3}" = "4 8" -a ${cpuport:-0} -eq 8 ] || \
+ [ "${vlan1ports:0:9}" = "0 1 2 3 8" -a "${vlan2ports:0:3}" = "4 8" -a ${cpuport:-0} -eq 8 ] || \
+ [ "${vlan2ports:0:9}" = "0 1 2 3 8" -a "${vlan1ports:0:3}" = "4 8" -a ${cpuport:-0} -eq 8 ];
+ then
+ ucidef_add_switch "switch0" \
+ "0:lan" "1:lan" "2:lan" "3:lan" "4:wan" "8@eth0"
+
+ elif [ "${vlan0ports:0:9}" = "1 2 3 4 8" -a "${vlan1ports:0:3}" = "0 8" -a ${cpuport:-0} -eq 8 ] || \
+ [ "${vlan1ports:0:9}" = "1 2 3 4 8" -a "${vlan2ports:0:3}" = "0 8" -a ${cpuport:-0} -eq 8 ] || \
+ [ "${vlan2ports:0:9}" = "1 2 3 4 8" -a "${vlan1ports:0:3}" = "0 8" -a ${cpuport:-0} -eq 8 ];
+ then
+ ucidef_add_switch "switch0" \
+ "1:lan" "2:lan" "3:lan" "4:lan" "0:wan" "8@eth0"
+
+ elif [ "${vlan0ports:0:9}" = "0 1 2 3 5" -a "${vlan1ports:0:3}" = "4 5" -a ${cpuport:-0} -eq 5 ] || \
+ [ "${vlan1ports:0:9}" = "0 1 2 3 5" -a "${vlan2ports:0:3}" = "4 5" -a ${cpuport:-0} -eq 5 ] || \
+ [ "${vlan2ports:0:9}" = "0 1 2 3 5" -a "${vlan1ports:0:3}" = "4 5" -a ${cpuport:-0} -eq 5 ];
+ then
+ ucidef_add_switch "switch0" \
+ "0:lan" "1:lan" "2:lan" "3:lan" "4:wan" "5@eth0"
+
+ elif [ "${vlan0ports:0:9}" = "1 2 3 4 5" -a "${vlan1ports:0:3}" = "0 5" -a ${cpuport:-0} -eq 5 ] || \
+ [ "${vlan1ports:0:9}" = "1 2 3 4 5" -a "${vlan2ports:0:3}" = "0 5" -a ${cpuport:-0} -eq 5 ] || \
+ [ "${vlan2ports:0:9}" = "1 2 3 4 5" -a "${vlan1ports:0:3}" = "0 5" -a ${cpuport:-0} -eq 5 ];
+ then
+ ucidef_add_switch "switch0" \
+ "1:lan" "2:lan" "3:lan" "4:lan" "0:wan" "5@eth0"
+
+ else
+ logger -t "01_network" "Unable to determine network configuration"
+ ucidef_set_interface_lan "eth0"
+ fi
+}
+
+configure_by_boardnum() {
+ local boardnum="$1"
+
+ case "$boardnum" in
+ # WAP54G, Sitecom WL-105b
+ "2" | \
+ "1024")
+ ucidef_set_interface_lan "eth0"
+ ;;
+
+ # Generic detection fallback
+ *)
+ configure_by_vlanports
+ ;;
+ esac
+}
+
+configure_by_boardtype() {
+ local boardtype="$1"
+ local boardnum="$2"
+
+ case "$boardtype" in
+ "bcm94710r4")
+ ucidef_set_interfaces_lan_wan "eth0" "eth1"
+ ;;
+
+ "0x0467")
+ ucidef_add_switch "switch0" \
+ "0:lan" "1:lan" "2:lan" "3:lan" "4:wan" "5@eth0"
+ ;;
+
+ "0x042f" | \
+ "0x0472")
+ # WL-500gP
+ if [ "$boardnum" = "45" ]; then
+ ucidef_add_switch "switch0" \
+ "0:wan" "1:lan" "2:lan" "3:lan" "4:lan" "5@eth0"
+
+ # Generic BCM94704
+ else
+ ucidef_set_interface_wan "eth1"
+ ucidef_add_switch "switch0" \
+ "0:lan" "1:lan" "2:lan" "3:lan" "4:lan" "5@eth0"
+
+ # MAC addresses on 4704 tend to be screwed up. Add a workaround here
+ local mac="$(nvram get et0macaddr)"
+ local pat="[0-9a-fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]"
+ pat="$pat:[0-9a-fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]"
+ pat="$pat:[0-9a-fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]"
+
+ case "$mac" in
+ $pat)
+ ucidef_set_interface_macaddr "lan" "$mac"
+ ucidef_set_interface_macaddr "wan" "$(macaddr_add "$mac" 1)"
+ ;;
+ esac
+ fi
+ ;;
+
+ # Buffalo WBR-B11 and Buffalo WBR-G54
+ "bcm94710ap")
+ ucidef_set_interface_wan "eth1"
+ ucidef_add_switch "switch0" \
+ "0:lan" "1:lan" "2:lan" "3:lan" "4:lan" "5@eth0"
+ ;;
+
+ *)
+ configure_by_boardnum "$boardnum"
+ ;;
+ esac
+}
+
+configure_by_model() {
+ local model="$1"
+ local boardtype="$2"
+ local boardnum="$3"
+
+ # Netgear WGT634U exception
+ if grep -sqE 'mtd0: 000(6|a)0000' /proc/mtd; then
+ ucidef_add_switch "switch0" \
+ "0:lan" "1:lan" "2:lan" "3:lan" "4:wan" "5@eth0"
+ return
+ fi
+
+ case "$model" in
+ "Asus WLHDD" | \
+ "Asus WL300G")
+ ucidef_set_interface_lan "eth1"
+ ;;
+
+ "Asus WL330GE")
+ ucidef_add_switch "switch0" "4:lan" "5t@eth0"
+ ;;
+
+ "Asus WL500G" | \
+ "Microsoft MN-700")
+ ucidef_set_interfaces_lan_wan "eth0" "eth1"
+ ;;
+
+ "Asus WL500GP V2")
+ ucidef_add_switch "switch0" \
+ "0:lan:4" "1:lan:3" "2:lan:2" "3:lan:1" "4:wan" "5@eth0"
+ ;;
+
+ "Asus RT-N12"* | \
+ "Buffalo WHR-G125" | \
+ "D-Link DIR-330" | \
+ "Motorola WR850G" | \
+ "Siemens SE505 V2")
+ ucidef_add_switch "switch0" \
+ "0:lan" "1:lan" "2:lan" "3:lan" "4:wan" "5@eth0"
+ ;;
+
+ "Asus WL700")
+ ucidef_add_switch "switch0" \
+ "0:wan" "1:lan" "2:lan" "3:lan" "4:lan" "5@eth0"
+ ;;
+
+ "Asus WL500W" | \
+ "Dell TrueMobile 2300")
+ ucidef_set_interface_wan "eth1"
+ ucidef_add_switch "switch0" \
+ "0:lan" "1:lan" "2:lan" "3:lan" "5@eth0"
+ ;;
+
+ "Asus RT-N16"* | \
+ "Linksys E3000 V1" | \
+ "Netgear WNR3500 V2" | \
+ "Netgear WNR3500L")
+ ucidef_add_switch "switch0" \
+ "0:wan" "1:lan:4" "2:lan:3" "3:lan:2" "4:lan:1" "8@eth0"
+ ;;
+
+ "Netgear WN2500RP V1")
+ ucidef_add_switch "switch0" \
+ "0:lan:4" "1:lan:3" "2:lan:2" "3:lan:1" "5@eth0"
+ ;;
+
+ *)
+ configure_by_boardtype "$boardtype" "$boardnum"
+ ;;
+ esac
+}
+
+
+model="$(cat /tmp/sysinfo/model)"
+boardtype="$(board_name)"
+
+case "$boardtype" in
+ *:*)
+ boardnum="${boardtype##*:}"
+ boardtype="${boardtype%:*}"
+ ;;
+esac
+
+board_config_update
+
+configure_by_model "$model" "$boardtype" "$boardnum"
+
+board_config_flush
diff --git a/target/linux/bcm47xx/base-files/etc/diag.sh b/target/linux/bcm47xx/base-files/etc/diag.sh
new file mode 100644
index 0000000000..91cf4bdf4b
--- /dev/null
+++ b/target/linux/bcm47xx/base-files/etc/diag.sh
@@ -0,0 +1,33 @@
+#!/bin/sh
+# Copyright (C) 2006 OpenWrt.org
+
+. /lib/functions/leds.sh
+
+get_status_led() {
+ for led in dmz power diag wps; do
+ status_led_file=$(find /sys/class/leds/ -name "*${led}*" | head -n1)
+ if [ ! -f $status_led_file ]; then
+ status_led=$(basename $status_led_file)
+ return
+ fi;
+ done
+}
+
+set_state() {
+ get_status_led
+
+ case "$1" in
+ preinit)
+ status_led_blink_preinit
+ ;;
+ failsafe)
+ status_led_blink_failsafe
+ ;;
+ preinit_regular)
+ status_led_blink_preinit_regular
+ ;;
+ done)
+ status_led_on
+ ;;
+ esac
+}
diff --git a/target/linux/bcm47xx/base-files/etc/init.d/wmacfixup b/target/linux/bcm47xx/base-files/etc/init.d/wmacfixup
new file mode 100755
index 0000000000..ee1b752201
--- /dev/null
+++ b/target/linux/bcm47xx/base-files/etc/init.d/wmacfixup
@@ -0,0 +1,33 @@
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2010 OpenWrt.org
+
+START=41
+
+boot() {
+ [ -d /sys/class/ieee80211 ] || exit
+
+ commit=0
+
+ fixup_wmac() {
+ local cfg="$1"
+ local cfmac
+
+ config_get cfmac "$cfg" macaddr
+
+ [ "$cfmac" != "00:90:4c:5f:00:2a" ] || {
+ local nvmac="$(nvram get il0macaddr 2>/dev/null)"
+ [ -n "$nvmac" ] && [ "$nvmac != "$cfmac ] && {
+ uci set wireless.$cfg.macaddr="$nvmac"
+ commit=1
+ }
+ }
+ }
+
+ config_load wireless
+ config_foreach fixup_wmac wifi-device
+
+ [ "$commit" = 1 ] && uci commit wireless
+}
+
+start() { :; }
+stop() { :; }
diff --git a/target/linux/bcm47xx/base-files/etc/uci-defaults/03_network_migration b/target/linux/bcm47xx/base-files/etc/uci-defaults/03_network_migration
new file mode 100644
index 0000000000..e430b41d48
--- /dev/null
+++ b/target/linux/bcm47xx/base-files/etc/uci-defaults/03_network_migration
@@ -0,0 +1,29 @@
+#!/bin/sh
+#
+# Copyright (C) 2014-2015 OpenWrt.org
+#
+
+uci show network | grep "\.vlan=0"
+[ $? -ne 0 ] && exit 0
+
+logger -t network "network config is invalid, creating new one"
+
+lan_proto="$(uci -q get network.lan.proto)"
+lan_ipaddr="$(uci -q get network.lan.ipaddr)"
+lan_netmask="$(uci -q get network.lan.netmask)"
+wan_proto="$(uci -q get network.wan.proto)"
+wan_ipaddr="$(uci -q get network.wan.ipaddr)"
+wan_netmask="$(uci -q get network.wan.netmask)"
+
+echo "" > /etc/config/network
+config_generate
+
+uci set network.lan.proto=$lan_proto
+uci set network.lan.ipaddr=$lan_ipaddr
+uci set network.lan.netmask=$lan_netmask
+uci set network.wan.proto=$wan_proto
+uci set network.wan.ipaddr=$wan_ipaddr
+uci set network.wan.netmask=$wan_netmask
+uci commit network
+
+exit 0
diff --git a/target/linux/bcm47xx/base-files/etc/uci-defaults/09_fix_crc b/target/linux/bcm47xx/base-files/etc/uci-defaults/09_fix_crc
new file mode 100644
index 0000000000..346a532998
--- /dev/null
+++ b/target/linux/bcm47xx/base-files/etc/uci-defaults/09_fix_crc
@@ -0,0 +1,7 @@
+#!/bin/sh
+#
+# Copyright (C) 2007 OpenWrt.org
+#
+#
+
+mtd fixtrx firmware